require({cache:{
'url:epi-cms/widget/templates/_SelectorBase.html':"﻿<div data-dojo-attach-point=\"inputContainer\" class=\"dijitReset dijitInputField dijitInline epi-resourceInputContainer\" id=\"widget_${id}\">\r\n    <div data-dojo-attach-point=\"displayNode, dropAreaNode, stateNode\" class=\"dijit dijitReset dijitInline dijitInlineTable dijitLeft dijitTextBox displayNode\">\r\n        <div class=\"dijitReset dijitLeft dijitInputField dijitInputContainer\">\r\n            <div data-dojo-attach-point=\"clearButton\" class=\"epi-clearButton\">&nbsp;</div>\r\n            <div data-dojo-attach-point=\"contentSelectorContainer\" class=\"contentSelectorContainer\"></div>\r\n            <div data-dojo-attach-point=\"resourceName\" class=\"dijitInline epi-resourceName dojoxEllipsis\" >\r\n                <span data-dojo-attach-point=\"selectedContentNameNode\"></span> <span data-dojo-attach-point=\"selectedContentLinkNode\"></span>\r\n            </div>\r\n        </div>\r\n    </div>\r\n</div>\r\n"}});
define("epi-cms/widget/_SelectorBase", [
    // dojo
    "dojo/_base/declare",
    "dojo/aspect",

    // dijit,
    "dijit/_CssStateMixin",
    "dijit/_TemplatedMixin",
    "dijit/_Widget",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/focus",

    // epi.shell
    "epi/dependency",
    "epi/shell/widget/_ValueRequiredMixin",

    // epi.cms
    "epi-cms/widget/_Droppable",
    "epi-cms/widget/_HasClearButton",
    "epi-cms/widget/_HasChildDialogMixin",
    "epi-cms/widget/ContentSelectorPlugAndPlay",

    // resources
    "dojo/text!./templates/_SelectorBase.html"
], function (
    // dojo
    declare,
    aspect,

    // dijit
    _CssStateMixin,
    _TemplatedMixin,
    _Widget,
    _WidgetsInTemplateMixin,
    focusManager,

    // epi.shell
    dependency,
    _ValueRequiredMixin,

    // epi.cms
    _Droppable,
    _HasClearButton,
    _HasChildDialogMixin,
    ContentSelectorPlugAndPlay,

    // resources
    template
) {
    return declare([_Widget, _TemplatedMixin, _WidgetsInTemplateMixin, _CssStateMixin, _HasChildDialogMixin, _HasClearButton, _Droppable, _ValueRequiredMixin], {
        // summary:
        //    Represents base class for item selector widget (a textbox and a browse button).
        // tags:
        //    public

        templateString: template,

        roots: null,

        value: null,

        // required: Boolean
        //		User is required to enter data into this field.
        required: false,

        // missingMessage: [public] String
        //    Message which is displayed when required is true and value is empty.
        missingMessage: "",

        // tooltipPosition: String[]
        //		See description of `dijit/Tooltip.defaultPosition` for details on this parameter.
        tooltipPosition: [],

        // canSelectOwnerContent: [public] Boolean
        //      Indicates whether the owner content that is being edited can be selected
        canSelectOwnerContent: false,

        contentRepositoryDescriptors: null,

        allowedDndTypes: [],

        // _hasBeenBlurred: [protected] Boolean
        //      Force show tooltip when clear a required value.
        _hasBeenBlurred: true,

        // _valueChangedPromise: [protected] Promise
        //      Promise which is set while the value in being changed within an asynchronous call.
        _valueChangedPromise: null,

        // contentSelectorPnP: [protected] Object
        //      Instance of ContentSelectorPlugAndPlay.
        contentSelectorPnP: null,

        _setSelectedContentNameAttr: function (value) {
            // summary:
            //		Sets the display name for selected content
            // tags:
            //    protected

            // set the text
            this.selectedContentNameNode.textContent = value;

            // set the title
            this._updateDisplayNodeTitle();
        },

        _setSelectedContentLinkAttr: function (value) {
            this.selectedContentLinkNode.innerHtml = value;
            this._updateDisplayNodeTitle();
        },

        _updateDisplayNodeTitle: function () {
            // summary:
            //		updates the tooltip with the current text of displayNode
            // tags:
            //    protected

            this.resourceName.title = this.resourceName.textContent.trim();
        },

        postCreate: function () {
            // summary:
            //      Post create initialization.
            // description:
            //      Setup related components.
            // tags:
            //      protected

            this.inherited(arguments);

            // After dnd into widget
            this.own(aspect.after(this, "onDrop", this.focus.bind(this)));

            this._setupContentSelector();
        },

        postMixInProperties: function () {
            // summary:
            //		Initialize properties
            // tags:
            //    protected

            this.inherited(arguments);

            if (!this.contentRepositoryDescriptors) {
                this.contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            }

            if (!this.roots && this.repositoryKey) {
                var settings = this.contentRepositoryDescriptors.get(this.repositoryKey);
                this.roots = settings.roots;
            }

            this._setupDialogSettings();
            this._setupContentSelectorDialogSettings();
        },

        _selectContent: function (event) {
            if (this.readOnly) {
                event.preventDefault();
                event.stopPropagation();
                return;
            }

            this._onDialogShow();
            this.contentSelectorPnP && this.contentSelectorPnP.selectContent();
        },

        _setupDialogSettings: function () {
            // summary:
            //      Setup settings for dialog.
            // tags:
            //      protected virtual

            this.dialogSettings = {};
        },

        _setupContentSelectorDialogSettings: function () {
            this.contentSelectorDialogSettings = this.contentSelectorDialogSettings || {
                canSelectOwnerContent: this.canSelectOwnerContent,
                showButtons: false,
                roots: this.roots,
                allowedTypes: this.allowedTypes,
                restrictedTypes: this.restrictedTypes,
                showAllLanguages: this.showAllLanguages,
                showSearchBox: this.showSearchBox,
                searchArea: this.searchArea,
                getCurrentValue: function () {
                    return this.value;
                }.bind(this)
            };
        },

        destroy: function (/*Boolean*/ preserveDom) {
            // summary:
            //      Destroy this class, cancelling any promises that are in progress.
            // tags:
            //      public
            this.inherited(arguments);

            // If there is a value change promise in progress then cancel it.
            if (this._valueChangedPromise) {
                this._valueChangedPromise.cancel();
                this._valueChangedPromise = null;
            }
        },

        _setReadOnlyAttr: function (value) {
            this._set("readOnly", value);

            this.contentSelectorPnP && this.contentSelectorPnP.set("readOnly", value);
            this.clearButton.style.display = value ? "none" : "";
            this.domNode.classList.toggle("dijitReadOnly", value);
        },

        _setIsListItemAttr: function (value) {
            if (value) {
                if (this.clearButton) {
                    this.clearButton.style.display = "none";
                }
            }
        },

        _setDisabledAttr: function (value) {
            this._set("disabled", value);
            this.contentSelectorPnP && this.contentSelectorPnP.set("disabled", value);
        },

        _setupContentSelector: function () {
            //summary:
            //    Try create instance of ContentSelectorPlugAndPlay and setup events.
            // tags:
            //    protected

            if (this.contentSelectorPnP && this.contentSelectorPnP.domNode) {
                // already setup
                return;
            }

            this.contentSelectorPnP = new ContentSelectorPlugAndPlay({
                actionsNodeOptions: this.actionsNodeOptions || {},
                dialogSettings: this.dialogSettings,
                contentSelectorDialogSettings: this.contentSelectorDialogSettings,
                readOnly: this.readOnly,
                isVisible: !this.get("value"), // only show for initial state.
                isInQuickEditMode: this.isInQuickEditMode,
                quickEditBlockId: this.quickEditBlockId
            });
            this.contentSelectorPnP.placeAt(this.contentSelectorContainer || this.domNode);
            this.contentSelectorPnP.startup();

            this.own(
                this.contentSelectorPnP,
                aspect.after(this.contentSelectorPnP, "onContentSelectorChange", this._onContentSelectorChange.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onSearchResultSelected", this._onSearchResultSelected.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onDialogExecute", this._onDialogExecute.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onDialogHide", this._onDialogHide.bind(this), true),
                aspect.after(this.contentSelectorPnP, "onDialogShow", this._onDialogShow.bind(this), true)
            );
        },

        _onDialogShow: function () {
            //summary:
            //    Handle onShow dialog event.
            // tags:
            //    protected

            this.isShowingChildDialog = true;
        },

        _onDialogExecute: function (/*object*/value) {
            //summary:
            //    Handle dialog close. Need override
            // value: string (content id) or object (link object)
            // tags:
            //    protected
        },

        _onContentSelectorChange: function (/*object*/value) {
            //summary:
            //    Handle dialog content selector is changed.
            // tags:
            //    protected
        },

        _onSearchResultSelected: function (/*object*/value) {
            //summary:
            //    Handle dialog content selector's search result is selected.
            // tags:
            //    protected
        },

        _onDialogHide: function () {
            //summary:
            //    Handle dialog hide. Need override
            // tags:
            //    protected

            this.isShowingChildDialog = false;

            // Return focus to the editor when the dialog closes.
            this.focus();
        },

        focus: function () {
            // summary:
            //       Put focus on this widget
            // tags:
            //      public

            if (this.contentSelectorPnP && this.contentSelectorPnP.isShowingChildDialog) {
                return;
            }

            var focusNode = this.focusNode || this.domNode;
            try {
                focusManager.focus(focusNode);
            } catch (e) {
                /*squelch errors from hidden nodes*/
            }
        },

        _onBlur: function () {
            // summary:
            //		This is where widgets do processing for when they stop being active,
            //		such as changing CSS classes.  See onBlur() for more details.
            // tags:
            //		protected

            this.inherited(arguments);

            this.validate();
        },

        onChange: function (value) {
            // summary:
            //    Fired when value is changed.
            //
            // value:
            //    The value
            // tags:
            //    public, callback
        },

        _updateDisplayNode: function (content) {
            //summary:
            //    Update widget's display text and title.
            // tags:
            //    protected

            this.domNode.classList.add("epi-noValue");
            this.resourceName.classList.add("dijitPlaceHolder");
            if (content) {
                this.domNode.classList.remove("epi-noValue");
                this.resourceName.classList.remove("dijitPlaceHolder");
            }
            this.set("selectedContentName", content ? content.name : "");
            this.contentSelectorPnP && this.contentSelectorPnP.set("isVisible", !content);
        }
    });
});
